#include "ConvexLens.h"

ConvexLens::ConvexLens()
{
}
ConvexLens::~ConvexLens()
{
}
float ConvexLens::Intersect(Vector rayOrg, Vector rayDir, Vector &norm)
{
	Vector temp = rayOrg - center1;
	Vector norm1, norm2;
	float a, b, c, det, tplus1, tminus1, tplus2, tminus2;
	float final1, final2;
	bool inside = false;

	a = pow(rayDir.Length(), 2);
	b = 2 * (temp * rayDir);
	c = pow(temp.Length(), 2.0f) - pow(radius1, 2.0f);
	det = pow(b, 2) - (4*a*c);

	//check collision against the first sphere
	if(det < 0)
		return(-1.0f);
	else
	{
		tplus1 = (-b + sqrt(det))/(2*a);
		if(tplus1 < 0)
			return(-1.0f);
		else
		{
			tminus1 = (-b - sqrt(det))/(2*a);
			if(tminus1 < 0)
			{
				final1 = (rayDir * tplus1).Length();
				Vector interPoint = rayOrg + (rayDir * tplus1);
				norm1 = interPoint - center1;
				final1 = tplus1;
				inside = true;
			}
			else
			{
				final1 = (rayDir * tminus1).Length();
				Vector interPoint = rayOrg + (rayDir * tminus1);
				norm1 = interPoint - center1;
				final1 = tminus1;
			}
		}
	}

	temp = rayOrg - center2;
	a = pow(rayDir.Length(), 2);
	b = 2 * (temp * rayDir);
	c = pow(temp.Length(), 2.0f) - pow(radius2, 2.0f);
	det = pow(b, 2) - (4*a*c);

	//check collision against the second sphere
	if(det < 0)
		return(-1.0f);
	else
	{
		tplus2 = (-b + sqrt(det))/(2*a);
		if(tplus2 < 0)
			return(-1.0f);
		else
		{
			tminus2 = (-b - sqrt(det))/(2*a);
			if(tminus2 < 0)
			{
				final2 = (rayDir * tplus2).Length();
				Vector interPoint = rayOrg + (rayDir * tplus2);
				norm2 = interPoint - center2;
				final2 = tplus2;
				inside = true;
			}
			else
			{
				final2 = (rayDir * tminus2).Length();
				Vector interPoint = rayOrg + (rayDir * tminus2);
				norm2 = interPoint - center2;
				final2 = tminus2;
			}
		}
	}

	if(inside == true)
	{
		//return(min(final1, final2));
		if(final1 < final2)
		{
			norm = norm1;
			return(final1);
		}
		else
		{
			norm = norm2;
			return(final2);
		}
	}
	else
	{
		//return(max(final1, final2));
		if(final1 > final2)
		{
			norm = norm1;
			return(final1);
		}
		else
		{
			norm = norm2;
			return(final2);
		}
	}
}