#ifndef RAYCASTER_H
#define RAYCASTER_H

#include "matrix.h"
#include "vectors.h"
#include "scene.h"
#include <math.h>

#define SHADOW_EPSILON (1.0e-3)
#define R_EPSILON (0.0039215686274)
#define SOFT_RAYS		50

const unsigned int maxReflectionDepth = 8;

void GetWorldRay(float x, float y, int width, int height, Vector& outPos, Vector& outDir);
Matrix4x4 BuildFOVPerspective(float vfov,float aspect,float n,float f);
Matrix4x4 BuildLookAt(Vector &eye,Vector &at,Vector &up);
Vector RayCast(float i, float j, int width, int height, bool bSoftShadows);
Vector CheckCollision(Vector &rayPos, Vector &rayDir, unsigned int recDepth, BaseShape *shapeIn, bool bSoftShadows);
Vector CalculateColor(Vector intersection, Vector rayDir, Vector norm, BaseShape* shape, unsigned int recDepth,
					  BaseShape *shapeIn, float dist, bool bSoftShadows);
float CheckShadow(Vector intersection, Vector dir, Vector norm, bool bSoftShadows);
bool SimpleCheckCollision(Vector rayPos, Vector rayDir);

#endif