#include "Sphere.h"

Sphere::Sphere()
{
}
Sphere::~Sphere()
{
}
//returns the dist if it intersects, -1 otherwise
float Sphere::Intersect(Vector rayOrg, Vector rayDir, Vector &norm)
{
	/*
	a = |d0|^2
	b = 2[(P0 - C)  dot  d0]
	c = |P0 - C|^2 - r^2
	P0 = rayOrg, d0 = rayDir
	C = center, r = radius
	discriminant = b^2 - 4ac
	
	*/
	Vector temp = rayOrg - center;
	float a, b, c, det, tplus, tminus;
	float ret;
	a = pow(rayDir.Length(), 2);
	b = 2 * (temp * rayDir);
	c = pow(temp.Length(), 2.0f) - pow(radius, 2.0f);
	det = pow(b, 2) - (4*a*c);

	if(det < 0)
		return(-1.0f);
	else
	{
		tplus = (-b + sqrt(det))/(2*a);
		if(tplus < 0)
			return(-1.0f);
		else
		{
			tminus = (-b - sqrt(det))/(2*a);
			if(tminus < -EPSILON)
			{
				ret = (rayDir * tplus).Length();
				Vector interPoint = rayOrg + (rayDir * tplus);
				norm = interPoint - center;
				return(tplus);
			}
			else
			{
				ret = (rayDir * tminus).Length();
				Vector interPoint = rayOrg + (rayDir * tminus);
				norm = interPoint - center;
				return(tminus);
			}
		}
	}
	return(-1.0f);
}
void Sphere::SetCenter(Vector c)
{
	center = c;
}
Vector Sphere::GetCenter()
{
	return(center);
}
void Sphere::SetRadius(float r)
{
	radius = r;
}
float Sphere::GetRadius()
{
	return(radius);
}