#ifndef _SCENE_
#define _SCENE_

#include <fstream>
#include <vector>
#include <string>
#include <math.h>
#include <stdlib.h>
#include "Sphere.h"
#include "Box.h"
#include "Polygon.h"
#include "Ellipsoid.h"
#include "ConvexLens.h"
#include "vectors.h"

struct Light
{
	Vector point, color;
	float radius;
};

class Scene
{
public:
	Scene();
	~Scene();

	bool OpenScene(char* fileName);
	void ReadSurfaceProperties(BaseShape* shape, std::string curLine, std::ifstream *in);
	void ClearScene();
	Vector viewPlaneCenter, viewPlaneU, viewPlaneV;
	Vector camera;
	Vector air, ambient;
	std::vector<Sphere> sphereList;
	std::vector<Box> boxList;
	std::vector<Poly> polyList;
	std::vector<Ellipsoid> ellipsoidList;
	std::vector<ConvexLens> lensList;
	std::vector<Light> lightList;
};

#endif