/*
Matt
Test of Win stuff
*/
/*// Include OLE. This is required by Gdiplus but is not included
// by it and won't always be included by windows.h.
#include <ole2.h>
// Include the Gdiplus header file to make the Gdiplus functions
// visible to the compiler.
#include <gdiplus.h>
// Tell the compiler to tell the linker to link with the Gdiplus
// library.
#pragma comment(lib, "gdiplus.lib")*/


#include <windows.h>										// We need to include windows.h
#include <iostream>
#include <math.h>
#include "scene.h"
#include "resource.h"
#include "RayCaster.h"
#include "test.h"

using namespace std;

#ifndef PI
#define PI 3.1415926538
#endif

// Standard callback function
LRESULT CALLBACK WinProc(HWND hwnd, UINT message, WPARAM wparam, LPARAM lparam);
//void DrawSquare(HWND hwnd, int xPos, int yPos, COLORREF color);
BOOL CALLBACK AboutDlgProc(HWND hwnd, UINT Message, WPARAM wParam, LPARAM lParam);

HWND         gWindH;         //!< The main window.
HDC          gBackDC; 
HBITMAP      gBackBM;
HBITMAP      gSaveBM;
//threading variables
HANDLE thread;
bool rendering=false;
AATypes aaSetting = ANone;
bool bSoftShadows = false;
int uniformSSNum = 4;	//for now we will do 4 across and 4 down.  Perhaps make this changable later

int check=0,xPos, yPos, oldxPos=0, oldyPos=0, trixPos=0, triyPos=0, radius, px, py;
COLORREF oColor=RGB(255,0,0), color1, color2;

bool sceneLoaded=false, run = false;
bool toFill;
int polyline=0;
bool menuclick=false, firstline=true, paused=true, filled=false;
extern bool selected;
extern bool vSelected;
bool pSelected, cSelected, drawing=false, deleted=false;
extern bool texpoints;
wchar_t *wstr1, *wstr2;

ULONG_PTR m_token;

Scene* myScene;
int WINAPI WinMain(HINSTANCE hinstance, HINSTANCE hprev, PSTR cmdline, int ishow)
{
//	HWND hwnd; // This will hold the handle to our window
    MSG msg; // This will hold any messages (such as a mouse click) that
			 // our window might receive

    WNDCLASSEX wndclassex = {0}; // This is our "window class" -- The "EX" stands
								// for "extended style" which gives us more options
							   // when creating our window (although we're going to
							  // completely ignore 'em)

	// Fill the fields we care about
	wndclassex.cbSize = sizeof(WNDCLASSEX); // Always must be set
    wndclassex.style = CS_HREDRAW | CS_VREDRAW | CS_OWNDC; // Window classes style
    wndclassex.lpfnWndProc = WinProc; // Pointer to where the WinProc() is defined
    wndclassex.hInstance = hinstance; // The handle to the instance of our window
	wndclassex.hIcon         = LoadIcon (NULL, IDI_WINLOGO);	// We call a function called LoadIcon that returns information about what icon we want.  I chose the Wndows Logo.  The NULL is in place of a hInstance.  We don't need one in this case.
    wndclassex.hCursor       = LoadCursor (NULL, IDC_ARROW);	// We call a function called LoadCursor that returns information about what cursor we want, I chose an arrow.  The NULL is in place of a hInstance.  We don't need one in this case.
	wndclassex.lpszClassName = "RayCaster"; // The name of our window class
	wndclassex.hIconSm       = LoadIcon (NULL, IDI_WINLOGO);	// We want the icon to be the windows logo.  This is the icon in the top left color of the window.
	wndclassex.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH); // This sets
																   // the background color
																  // of the window to white
	//wndclassex.lpszMenuName  = "My_Menu";						// We use the menu ID in order to use our menu we made in the MSVS editor. 													// *Note* It MUST be a string, so make sure your ID in the resouce editor is "My_Menu" with quotes.
	
    

    RegisterClassEx(&wndclassex); // Register the window class so calls to CreateWindow()
								 // and CreateWindowEx() will know what window class to
								// use when creating the window
	HMENU menu = NULL; // This is the "handle" for a menu
	menu = LoadMenu(hinstance,MAKEINTRESOURCE(My_Menu));
	
    gWindH = CreateWindowEx(NULL, // Extra window attributes, NULL means none
						  "RayCaster", // Name we gave our WNDCLASSEX			
						  "RayTracer", // Text for the title bar
						  WS_OVERLAPPEDWINDOW, // Style of window (see MSDN for full description)
						  CW_USEDEFAULT, // Upper left xPos of window (Windows picks default)
						  CW_USEDEFAULT, // Upper left yPos of window (Windows picks default)
						  500, // Width of window in pixels
						  500, // Height of window in pixels
						  NULL, // Handle to "parent window" (we have none, this is the parent)
						  menu, // Handle to a menu (we have none)
						  hinstance, // Handle to instance of this window (passed in by WinMain())
						  NULL); // "Extra info" to pass to the WinProc (we have none)
	DragAcceptFiles(gWindH, true);

	myScene = new Scene();
		/*Gdiplus::GdiplusStartupInput input;
		Gdiplus::GdiplusStartupOutput output = {0};
		
		Gdiplus::GdiplusStartup(&m_token, &input, &output);

		char *ErrorMessage;
		bool LoadSuccessful=false;
		LoadSuccessful=LoadBitmapFile(".\\whitebox.bmp",&texture[0].bitmap,&ErrorMessage);
		if (!LoadSuccessful)
		{
			MessageBox(gWindH,"Failed to load Texture 1.","Texture load error",MB_OK);
		}
		LoadSuccessful=LoadBitmapFile(".\\coffeecup_32bit.tif",&texture[1].bitmap,&ErrorMessage);
		if (!LoadSuccessful)
		{
			MessageBox(gWindH,"Failed to load Texture 2.","Texture load error",MB_OK);
		}
		LoadSuccessful=LoadBitmapFile(".\\bluedot_32bit.tif",&texture[2].bitmap,&ErrorMessage);
		if (!LoadSuccessful)
		{
			MessageBox(gWindH,"Failed to load Texture 3.","Texture load error",MB_OK);
		}*/
		RECT  rect;
		GetClientRect(gWindH, &rect);
		gBackDC = CreateCompatibleDC(GetDC(gWindH));
		gBackBM = CreateCompatibleBitmap(GetDC(gWindH), rect.right, rect.bottom);
		gSaveBM = (HBITMAP)SelectObject(gBackDC, gBackBM);

		ShowWindow(gWindH, ishow);
		UpdateWindow(gWindH);

		/*if(!hwnd)
			return EXIT_FAILURE; // Something really bad happened!*/

		/*HDC hdc = GetDC(hwnd);

		if(!hdc)
			return EXIT_FAILURE;*/
		

	/*while (GetMessage (&msg, NULL, 0, 0))					// We need to pass in the address of "msg" because GetMessage fills in the structure "msg".  We pass in NULL for the HWND because that makes GetMessage check ALL windows that use our WndProc.
    {														// The rest we pass in 0, they are not important.
		TranslateMessage (&msg);							// "The TranslateMessage() function translates virtual-key messages into character messages." This basically means it translates it so windows understands it.
		DispatchMessage (&msg);								// "The DispatchMessage() function dispatches a message to a window procedure."  - This means it handles the message, like it the message was to close the window, it closes the window.
    }*/

	while(true)
    {
		if(PeekMessage(&msg,0,0,0,PM_REMOVE))
		{
			// If a quit message, break the loop.
			if(msg.message == WM_QUIT)
				break;
			else
			{
			TranslateMessage (&msg);
			DispatchMessage(&msg);
			}
		}
		ThreadParam windowVars;
		windowVars.dc = GetDC(gWindH);
		windowVars.wind = gWindH;
		if(sceneLoaded == true && run == false)
			thread = CreateThread(0,0,RenderWindow,&windowVars,THREAD_SUSPEND_RESUME,0);
		//RenderWindow(windowVars);
		Sleep(10);
	}	

	DestroyMenu(menu); // This frees the menu that we created
	DestroyWindow();
	delete myScene;

	//ReleaseDC(hwnd, hdc);//very important for memory purposes

	return (int)msg.wParam;
}
//
LRESULT CALLBACK WinProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
   	// Depending on the message -- we'll do different stuff
	PAINTSTRUCT ps;
	RECT  rect;
	HDROP dropped;
	UINT nFiles, i;
	TCHAR szFileName[_MAX_PATH];
	float ratio;
	xPos = LOWORD(lParam); //x Position of Mouse
	yPos = HIWORD(lParam); //y Position of Mouse
	//TCHAR tchar;
    switch(message)
    {
		/////////// *NEW* /////////// CHECK FOR MENU CLICK ////////// *NEW* ///////////


	case WM_CREATE:
		//Initialize();
		toFill=false;
		menuclick=false;
		break;
		case WM_COMMAND:									// This message is sent when the user selects a command item from a menu, and some other things.
			switch(LOWORD(wParam))
			{
			case IDM_QUIT:			
				DestroyEverything();	// If we check the Low-bits (LOWORD) of the DWORD wParam we can see what menu item they clicked on.
				//Gdiplus::GdiplusShutdown(m_token);
				PostQuitMessage(0);							// If they clicked on the menu ID: IDM_QUIT, then we want to post the quit message.
				break;

			case ID_HELP_ABOUT:
				{
					int ret = (int)(DialogBox(GetModuleHandle(NULL), MAKEINTRESOURCE(IDD_ABOUT),
						hwnd, AboutDlgProc));
					if(ret == -1)
					{
						MessageBox(hwnd, "Dialog failed!", "Error",
							MB_OK | MB_ICONINFORMATION);
					}
				}
				break;

			case ID_FILE_CLEAR:
				DestroyEverything();
				firstline=true;
				drawing=false;
				menuclick=true;
				check=0;
				break;

			case ID_FILE_DEFAULT:
				Default();
				menuclick=true;
				break;
			case ID_FILE_PAUSE:
				if(paused==false)
					paused=true;
				else
					paused=false;
				menuclick=true;
				break;

			/*case ID_FILE_START:
				Initialize();
				break;*/

			case ID_FILE_OPENSCENE:
				//get the file to read in
				break;
			case ID_COLOR_RED:
				oColor=RGB(255,0,0);
				menuclick=true;
				break;

			case ID_COLOR_GREEN:
				oColor=RGB(0,255,0);
				menuclick=true;
				break;

			case ID_COLOR_BLUE:
				oColor=RGB(0,0,255);
				menuclick=true;
				break;

			case ID_SHAPE_LINE:
				menuclick=true;
				break;	

			case ID_SHAPE_SQUARE:
				menuclick=true;
				break;
			case ID_ANIMATION_LINEARBOUNCE:
				menuclick=true;
				//menuitem=linearbounce;
				break;
			case ID_SHAPE_CIRCLE:
				menuclick=true;
				break;
			case ID_ANIMATION_STATIC:
				menuclick=true;
				break;
			case ID_SHAPE_ELLIPSE:
				menuclick=true;
				break;
			case ID_ANIMATION_CIRCULAR:
				menuclick=true;
				break;
			case ID_ANIMATION_CIRCULARARC:
				menuclick=true;
				break;
			case ID_ANIMATION_FREE:
				menuclick=true;
				break;
			case ID_SHAPE_TRIANGLE:
				menuclick=true;
				break;
			case ID_SHAPE_BALL:
                menuclick=true;
				break;

			case ID_SHAPE_POLYGON:
				menuclick=true;
				break;

			case ID_ATTRIBUTES_TEXTURE:
				menuclick=true;
				break;
			case ID_ATTRIBUTES_COLOR:
				menuclick=true;
				break;
			case ID_ATTRIBUTES_COLORCOMBINE:
				menuclick=true;
				break;
			case ID_COLORCOMBINE_DECAL:
				menuclick=true;				
				break;
			case ID_COLORCOMBINE_MODULATE:
				menuclick=true;				
				break;
			case ID_COLORCOMBINE_REPLACE:
				menuclick=true;				
				break;
			case ID_ANTIALIASING_UNIFORMSUPERSAMPLING:
				aaSetting = UniformSS;
			break;
			case ID_ANTIALIASING_JITTEREDSAMPLING:
				aaSetting = Jittered;
			break;
			case ID_ANTIALIASING_NONE:
				aaSetting = ANone;
			break;
			case ID_SOFTSHADOWS_OFF:
				bSoftShadows = false;
			break;
			case ID_SOFTSHADOWS_ON:
				bSoftShadows = true;
			break;
			}
		case WM_KEYDOWN:
			switch(wParam)
			{
			case VK_DELETE:
				/*if(cSelected == true)
				{
					circDel(pCircle);
					cSelected=false;
					check=0;
					deleted = true;
				}
				else if(selected == true)
				{
					delTriangle(pTemp);
					selected=false;
					check=0;
					deleted = true;
				}
				else if(pSelected == true)
				{
					delPoly(pPolygon);
					pSelected=false;
					check=0;
					deleted = true;
				}*/
				break;
				default:
					break;
			}
			
		case WM_CHAR:
			/*tchar = (TCHAR)wParam;
			if(tchar == 'a')
			{
				if(toFill == false)
					toFill = true;
				else
				{
					toFill = false;
					clearPolyFill();
					filled=false;
				}
			}
			tchar=0;*/
		break;

		case WM_LBUTTONDOWN:
			break;
		case WM_LBUTTONUP:
			break;
		case WM_RBUTTONDOWN:
			break;

		case WM_DROPFILES:
			dropped = (HDROP)wParam;
			nFiles = ::DragQueryFile(dropped, (UINT) -1, NULL, 0);
			for (i = 0; i < nFiles; i++)
			{
				::DragQueryFile(dropped, i, szFileName, _MAX_PATH);
				myScene->OpenScene((char *)szFileName);
			}  // end for
			::DragFinish(dropped);
			//set the aspect ratio
			ratio = myScene->viewPlaneU.Length() / myScene->viewPlaneV.Length();
			RECT tempRect;
			GetWindowRect(hwnd, &tempRect);
			MoveWindow(hwnd, tempRect.left, tempRect.top, (int)((tempRect.bottom - tempRect.top) * ratio),
				tempRect.bottom - tempRect.top, true);

			GetClientRect(gWindH, &rect);
			gBackDC = CreateCompatibleDC(GetDC(gWindH));
			gBackBM = CreateCompatibleBitmap(GetDC(gWindH), rect.right, rect.bottom);
			gSaveBM = (HBITMAP)SelectObject(gBackDC, gBackBM);


			sceneLoaded = true;
		break;
		case WM_PAINT:
			BeginPaint(hwnd,&ps);
			if(rendering == false)
			{
				GetClientRect(hwnd,&rect);
				FillRect(GetDC(hwnd),&rect,(HBRUSH)GetStockObject(WHITE_BRUSH));
				BitBlt(GetDC(hwnd),0,0,rect.right,rect.bottom,gBackDC,0,0,SRCCOPY);
			}
			EndPaint(hwnd,&ps);
				return 0;
		break;
		case WM_DESTROY:									// This message is sent when the user closes the window.
			
			PostQuitMessage(0);								// You must call this function or else you will need to do control-alt-delete and manually close the program from the programs queue.  0 = WM_QUIT.
															// This function actually puts a message on the message queue.  
			break;												

    } // end of switch(message)

    return DefWindowProc(hwnd, message, wParam, lParam);
}
//
BOOL CALLBACK AboutDlgProc(HWND hwnd, UINT Message, WPARAM wParam, LPARAM lParam)
{
    switch(Message)
    {
        case WM_INITDIALOG:

        return TRUE;
        case WM_COMMAND:
            switch(LOWORD(wParam))
            {
                case IDOK:
                    EndDialog(hwnd, IDOK);
                break;
            }
        break;
        default:
            return FALSE;
    }
    return TRUE;
}
//
DWORD WINAPI RenderWindow(void* windowVars)
/*! Render a window.

    @param wind  The destination window.
    @param dc    The destination device context.
*/
{ 
	RECT  rect;
	int width, height;
	float i, j, uW, uH, numPerPixel;
	float change;
	ThreadParam *tp = reinterpret_cast<ThreadParam*>(windowVars);
	//COLORREF color;
  // Clear the window.
	GetClientRect(tp->wind,&rect);
	FillRect(gBackDC,&rect,(HBRUSH)GetStockObject(WHITE_BRUSH));
	width = rect.right - rect.left;
	height = rect.bottom - rect.top;
	Vector curColor, finalColor;
	
	srand(GetTickCount());
	change = 1.0f/uniformSSNum;
	numPerPixel = pow((float)uniformSSNum, 2.0f);
	//RGB(finalColor.x * 255, finalColor.y * 255, finalColor.z * 255)
	if(sceneLoaded == true && run == false)
	{
		run = true;
		rendering = true;
		for(i=0; i < height; ++i)
		{
			for(j=0; j < width; ++j)
			{
				if(aaSetting == ANone)
					finalColor = RayCast(j, i, width, height, bSoftShadows);
				else if(aaSetting == UniformSS)
				{
					curColor.x = curColor.y = curColor.z = 0;
					for(uW = 0; uW < uniformSSNum; ++uW)
					{
						for(uH = 0; uH < uniformSSNum; ++uH)
						{
							curColor += RayCast(j - 0.5f + (uW * change), i - 0.5f + (uH * change), width, height, bSoftShadows);
						}
					}
					finalColor = curColor / numPerPixel;
				}
				else if(aaSetting == Jittered)
				{
					curColor.x = curColor.y = curColor.z = 0;
					for(uW = 0; uW < uniformSSNum; ++uW)
					{
						for(uH = 0; uH < uniformSSNum; ++uH)
						{
							curColor += RayCast(j - 0.5f + (uW * change) + ((float)rand()/((float)RAND_MAX * (float)uniformSSNum)),
								i - 0.5f + (uH * change) + ((float)rand()/((float)RAND_MAX * (float)uniformSSNum)), width, height, bSoftShadows);
						}
					}
					finalColor = curColor / numPerPixel;
				}
				SetPixel(gBackDC, (int)j, (int)(height - i - 1), RGB(finalColor.x * 255, finalColor.y * 255, finalColor.z * 255));
			}
			if((int)i%5 == 0)
				BitBlt(tp->dc,0,0,rect.right,rect.bottom,gBackDC,0,0,SRCCOPY);
		}
		//blt whatever lines are left
		BitBlt(tp->dc,0,0,rect.right,rect.bottom,gBackDC,0,0,SRCCOPY);
		run = false;
		sceneLoaded = false;
	}
  //BitBlt(dc,0,0,rect.right,rect.bottom,gBackDC,0,0,SRCCOPY);
	rendering = false;
	return(0);
}
//
void DestroyWindow(void)
/*! Clean up the window and backbuffer objects.
*/
{
  SelectObject(gBackDC,gSaveBM);
  DeleteObject(gBackBM);
  DeleteDC(gBackDC);
  DestroyWindow(gWindH);
  //UnregisterClass("Tester", hinstance);
  UnregisterClass("RayCaster", GetModuleHandle(0));
}
//
double GetAngle(int x, int y)
{
	int temp=x, temp2=y;
	y=abs(y);
	x=abs(x);
	double tempd=(double)y/(double)x;
	double angle=atan(tempd);
	if(temp < 0 && temp2 >= 0)
		angle+=(PI/2);
	else if(temp <= 0 && temp2 < 0)
		angle+=PI;
	else if(temp >= 0 && temp2 < 0)
		angle+=((3*PI)/2);
	return(angle);
}
//
void DestroyEverything()
{
}
//
void Default()
{
	menuclick=true;
	check=0;
	oColor=RGB(255,0,0);
	/*curShape=sBall;
	curAttribute=mColor;*/
}
//
void DrawTriLine(float xleft, float xright, int y, Color left, Color right)
{
	//COLORREF cLeft=RGB((left.r*255), (left.g*255), (left.b*255));
	float dxr, dxg, dxb, width;
	COLORREF c=RGB((left.r*255), (left.g*255), (left.b*255));
	width=xright-xleft;
	dxr=(right.r - left.r)/width;
	dxg=(right.g - left.g)/width;
	dxb=(right.b - left.b)/width;

	while(xleft <= xright)
	{
		SetPixel(gBackDC, (int)xleft, y, c);
		left.r+=dxr;
		left.g+=dxg;
		left.b+=dxb;
		c=RGB((left.r*255), (left.g*255), (left.b*255));
		xleft++;
	}
}
//
