#ifndef _LIST
#define _LIST

#include<iostream>
#include<vector>
#include<windows.h>
#include "vectors.h"
//#include "triangle.h"
//#include "cs230bitmap.h"

using namespace std;	//this should not be in the framework.  Get rid of later @Matt

enum AATypes { ANone, UniformSS, Jittered };

struct ThreadParam
{
	HWND wind;
	HDC dc;
};

DWORD WINAPI RenderWindow(void* windowVars);
void DestroyWindow(void);
double GetAngle(int x, int y);
void DestroyEverything();
void Default();

//initiates the struct to consist of two elements
enum animType{aStatic, aLine, aCircle, aCircleArc, aEllipse, aFree};
enum shapes{sLine, sSquare, sCircle, sEllipse, sTriangle, sPoly, sBall};
enum enumTexture{One, Two, Three, None};
enum enumAttributes{mTexture, mColor, mColorCombine};
enum TextureMode{WRAP_X, WRAP_Y, MIRROR_X, MIRROR_Y, CLAMP};
enum CombineMode{REPLACE, DECAL, MODULATE};

/*struct MyTexture
{
	CS230Bitmap bitmap; //Use DrawXY(dc,topleftx,toplefty)
};*/

struct Point
{
	float x;
	float y;
};
struct Color
{
	float r, g, b, a;
};

struct TexCoord
{
	float u, v;
};

struct elem{
  Point topleft;
  Point bottomright;
  COLORREF sColor;
  Point beginLine;
  Point endLine;
  elem *next;
  int gFrame;
  int anim;
  };

struct lineElem
{
  Point beginLine;
  Point endLine;
  COLORREF sColor;
  lineElem *next;
  //vector from the endpoint to the begin point (endLine - beginLine)
  Vector lVector;
};

struct circleElem{
  Point Center;
  Point sCenter;
  Point beginLine;
  float xVelocity;
  float yVelocity;
  int anim;
  int radius; 
  COLORREF sColor;
  circleElem *next;
  };

struct ellipseElem{
  Point Center;
  Point sCenter;
  int anim;
  int minoraxis; 
  int majoraxis;
  COLORREF sColor;
  ellipseElem *next;
  };

struct Vertex
{
	float x, y;
	Color col;
	TexCoord tex;
};

struct triangleElem
{
	Vertex v[3];
	TextureMode tm;
	CombineMode cm;
	int anim;
	int gFrame;
	Point animPoint;
	int attribute;
	triangleElem *next;
	bool poly;
};

struct polygonElem
{
	vector<lineElem*> polygon;
	//SCOTT
	#if 0
	vector<triangleElem*> ptriangles;
	#endif
	polygonElem *next;
};
struct animCircleElem
{
	Point center, cur, prev;
	int radius, tframes, curframe;
	double alpha, angle;//step size
	double cosa, sina;
	animCircleElem *next;
};

   #endif