#ifndef VECTORS_H
#define VECTORS_H
class Vector
{
public:

	Vector() : x(0.f), y(0.f), z(0.f) {};
	Vector( float a, float b, float c ) : x(a), y(b), z(c) {};

	//negation
	Vector operator -(void);
	Vector operator + (Vector v);
	Vector& operator += (Vector v);
	Vector& operator += (float f);
	Vector& operator -= (Vector v);
	Vector operator -(Vector v);
	Vector operator ^(Vector v);
	float operator * (Vector v);	// dot product
	//scalar multiplication
	Vector operator * (float s);
	//scalar division
	Vector operator / (float s);
	//returns the normal of the vector
	Vector& Normal();
	//normalizes a vector
	Vector Normalize();
	//returns the magnitute of a vector
	float Length();
	//returns the squared magnitute of a vector
	float LengthSq();
	//returns a normal of the member vector
	Vector NormalNoMod();
	float x, y, z;
};
#endif